

/**
 * Created by dan on 6/14/17.
 */
public class StringUtilities {
    /**
     * @return `Hello World` as a string
     */
    public String getHelloWorld() {
        return "Hello World";
    }

    /**
     * @param firstSegment a string to be added to
     * @param secondSegment a string to add
     * @return the concatenation of two strings, `firstSegment`, and `secondSegment`
     */
    public String concatenation(String firstSegment, String secondSegment){
        return firstSegment + secondSegment;
    }

    /**
     * @param firstSegment a string to be added to
     * @param secondSegment a string to add
     * @return the concatenation of an integer, `firstSegment`, and a String, `secondSegment`
     */
    public String concatenation(int firstSegment, String secondSegment){
        String newSegment = firstSegment + secondSegment;
        return newSegment;
    }

    /**
     * @param input a string to be manipulated
     * @return the first 3 characters of `input`
     */
    public String getPrefix(String input){
        return input.substring(0, 3);
    }

    /**
     * @param input a string to be manipulated
     * @return the last 3 characters of `input`
     */
    public String getSuffix(String input){
        String suffix = input.substring(input.length() - 3, input.length());
        return suffix;
    }
    

    /**
     * @param inputValue the value to be compared
     * @param comparableValue the value to be compared against
     * @return the equivalence of two strings, `inputValue` and `comparableValue`
     */
    public Boolean compareTwoStrings(String inputValue, String comparableValue){
        return inputValue.equals(comparableValue);
    }

    /**
     * @param inputValue the value input from user
     * @return the middle character of `inputValue`
     */
    public Character getMiddleCharacter(String inputValue){
        int mid = inputValue.length() / 2;
        char middleChar = inputValue.charAt(mid);
        
        if (inputValue.length() % 2 == 0) {
            middleChar = inputValue.charAt(mid - 1);
    }
    return middleChar;
    }

    /**
     * @param spaceDelimitedString a string, representative of a sentence, containing spaces
     * @return the first sequence of characters
     */
    public String getFirstWord(String spaceDelimitedString){
        int x = spaceDelimitedString.indexOf(" ");
        String firstWord = spaceDelimitedString.substring(0, x);
        return firstWord;
    }

    /**
     * @param spaceDelimitedString a string delimited by spaces
     * @return the second word of a string delimited by spaces.
     */
    public String getSecondWord(String spaceDelimitedString){
        int x = spaceDelimitedString.indexOf(" ") + 1;
        int last = spaceDelimitedString.indexOf(" ", x);
        
        if (last == -1) {
            last = spaceDelimitedString.length();
        }
        String secondWord = spaceDelimitedString.substring(x, last);
        return secondWord;
    }

    /**
     * @param stringToReverse
     * @return an identical string with characters in reverse order.
     */
    public String reverse(String stringToReverse){
       if (stringToReverse == null || stringToReverse.isEmpty()) {
           return stringToReverse;
    }
    String reversedString = "";
    for (int i = stringToReverse.length() - 1; i >= 0; i--) {
        reversedString = reversedString + stringToReverse.charAt(i);
    }
    return reversedString;
}
    


    /**
     * @param input
     * @return an identical string with spaces removed.
     */
    public String removeWhitespace(String input){
    String trimmedWord = input.replaceAll(" ", "");
        return trimmedWord;
    }

    /**
     * @param input
     * @return an identical string with spaces in the front and end removed.
     */
    public String trim(String input){
        String trimmedWord = input.trim();
        return trimmedWord;
    }
}
 